%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%               PME3534: Cundução Térmica          %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%  NOME: Alexandre H. Costa Rossi - N°USP: 9348950 %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%  NOME: Daniela Yumi Sekiguchi   - N°USP: 9344549 %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%  NOME: Matheus Kenichi Gomes    - N°USP: 9344390 %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%               Sub-rotina            %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%   1 1.a) Extract node coordinates   %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%  1.b) Extract topology information  %%%%%%%%%%%%%%%%%%%%%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all
format short e

aux_linha="";
nelem = 0

#Palavras de referência para encontrar 
procura_nos = "$Nodes";
procura_elem = "$Elements";
arq_mesh="dois_tetraedros.msh";             #arquivo gerado no gmsh, msh version 2 ASCII



%%%%%%%%%%%%%%%%%%%%   1 1.a) Extract node coordinates   %%%%%%%%%%%%%%%%%%%%%%%

mesh = fopen(arq_mesh, 'r');                #abre o arquivo mesh no mode leitura

while (! feof (mesh) )                      #enquanto não chega no final do arquivo 
  linha = fgetl (mesh);
  if (strncmp(procura_nos,linha,6))         #procura pela palavra definida 
      aux_linha = fgetl (mesh);             #se linhas é igual a nodes
      nnos=str2num(aux_linha);              #string to number
      coordenadas = zeros(nnos,3);          #cria a matriz de coordenadas
      for i=1:nnos 
         linha = fgetl (mesh); 
         aux=sscanf(linha,"%lf");
         coordenadas(i,1)=aux(1);           #consolidando coordenadas
         coordenadas(i,2)=aux(2);           #consolidando coordenadas
         coordenadas(i,3)=aux(3);           #consolidando coordenadas
         coordenadas(i,4)=aux(4);           #consolidando coordenadas
      end
  end
endwhile

fclose(mesh);                               #fecha o arquivo mesh



%%%%%%%%%%%%%%%%%%%%  1.b) Extract topology information  %%%%%%%%%%%%%%%%%%%%%%%

mesh=fopen(arq_mesh, 'r')                   #abre o arquivo mesh
while (! feof (mesh) )
  linha = fgetl (mesh);
  if (strncmp(procura_elem,linha,9))
      aux_linha = fgetl (mesh);             #se linhas é igual a elements
      nelem = str2num(aux_linha);           #string to number
      topologia=zeros(nelem,5);                  #cria a matriz de topologia
      for i=1:nelem
         linha = fgetl (mesh); 
         aux_topo=sscanf(linha,"%lf");
         n_colunas=aux_topo(3);             #pegando o númeno de tags
         topologia(i,1)=aux_topo(1);             #numero do elemento
         topologia(i,2)=aux_topo(1+n_colunas+3); #pulando tags
         topologia(i,3)=aux_topo(2+n_colunas+3); #pulando tags
         topologia(i,4)=aux_topo(3+n_colunas+3); #pulando tags
         topologia(i,5)=aux_topo(4+n_colunas+3); #pulando tags
      end
  end
endwhile
fclose(mesh)                                #fecha o arquivo mesh

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
