clc; clear;
format long
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% abre a malha e calcula as matrizes locais
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
k_basal=2.0; % basal resistivity in Ohm.m

LOCAL

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Criando matriz global
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% nelem -> número de elementos

M_global = zeros(nelem);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Criando vetor excitação global
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% nnos -> número de nos

b = zeros(nnos,1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% preenche a matriz global
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Para cada elemento, será utilizado a matriz local
% a fim de completar a matriz global. Será necessário
% a matriz topologia também.
% M -> matriz local
% topologia -> matriz topologia

for elemento_i=1:nelem
    for i=1:4
        linha = topologia(elemento_i, i+1); % o +1 é necessário pois a
                                            % primeira coluna possui o 
                                            % 'id' do elemento
        for j=1:4
            coluna = topologia(elemento_i, j+1); % mesma regra que o anterior
            
            
            % Dado que os valores de cada elemento estão representados 
            % por uma linha na matriz local (M), é necessário pegar o 
            % indice desse valor, dado o 'i' e 'j'.
            idx_M = (i-1)*4 + j; 
            
            % Agora que possui o indice, a linha e a coluna, basta somar
            % na matriz global.
            M_global(linha, coluna) = M_global(linha, coluna) + M(elemento_i, idx_M);
            
        end
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% impoe condições de contorno
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[Neu,Dirich]=condicoes_contorno;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% impoe condições de contorno
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[linhas,colunas]=size(Dirich);
for i=1:linhas
  [M_global,b]=set_dirichlet (M_global, b, Dirich(i,1), Dirich(i,2));
end


[linhas,colunas]=size(Neu);
for i=1:linhas
  b=set_neumann (b, Neu(i,1), Neu(i,2));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calcula a solução, vetor x
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
x=inv(M_global)*b;
x

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Escreve resultado para visualização
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
num_bytes = save_pos ("resultado", coordenadas, topologia, x)





