function M = matrizes_locais(coord, topo, N, condutividade)
% Gera as matrizes locais de todos os elementos
% 
% IN: coord: matriz com a relao de coordenadas
%     topo: matriz de topologia dos elementos
%     N: nmero de elementos
%     k: matriz de condutividade
% 
% OUT: M: matriz Nx16 contendo as N matrizes locais
%         com dimenso 1x16.

    coord(:,1) = [];
    topo(:,1) = [];
    
    M = zeros(N, 16);
    for i = 1:N
        l = coord(topo(i,1),:);
        m = coord(topo(i,2),:);
        n = coord(topo(i,3),:);
        o = coord(topo(i,4),:);
        
        M(i,:) = matriz_local(l,m,n,o,condutividade(i,:));
    end
end
